const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Subscriber_activitiesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscriber_activities = await db.subscriber_activities.create(
      {
        id: data.id || undefined,

        action: data.action || null,
        object: data.object || null,
        timestamp: data.timestamp || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await subscriber_activities.setSubscriber(data.subscriber || null, {
      transaction,
    });

    await subscriber_activities.setOrganizations(data.organizations || null, {
      transaction,
    });

    return subscriber_activities;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const subscriber_activitiesData = data.map((item, index) => ({
      id: item.id || undefined,

      action: item.action || null,
      object: item.object || null,
      timestamp: item.timestamp || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const subscriber_activities = await db.subscriber_activities.bulkCreate(
      subscriber_activitiesData,
      { transaction },
    );

    // For each item created, replace relation files

    return subscriber_activities;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const subscriber_activities = await db.subscriber_activities.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.action !== undefined) updatePayload.action = data.action;

    if (data.object !== undefined) updatePayload.object = data.object;

    if (data.timestamp !== undefined) updatePayload.timestamp = data.timestamp;

    updatePayload.updatedById = currentUser.id;

    await subscriber_activities.update(updatePayload, { transaction });

    if (data.subscriber !== undefined) {
      await subscriber_activities.setSubscriber(
        data.subscriber,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await subscriber_activities.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return subscriber_activities;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscriber_activities = await db.subscriber_activities.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of subscriber_activities) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of subscriber_activities) {
        await record.destroy({ transaction });
      }
    });

    return subscriber_activities;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscriber_activities = await db.subscriber_activities.findByPk(
      id,
      options,
    );

    await subscriber_activities.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await subscriber_activities.destroy({
      transaction,
    });

    return subscriber_activities;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const subscriber_activities = await db.subscriber_activities.findOne(
      { where },
      { transaction },
    );

    if (!subscriber_activities) {
      return subscriber_activities;
    }

    const output = subscriber_activities.get({ plain: true });

    output.subscriber = await subscriber_activities.getSubscriber({
      transaction,
    });

    output.organizations = await subscriber_activities.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.subscribers,
        as: 'subscriber',

        where: filter.subscriber
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.subscriber
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.subscriber
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.action) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'subscriber_activities',
            'action',
            filter.action,
          ),
        };
      }

      if (filter.object) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'subscriber_activities',
            'object',
            filter.object,
          ),
        };
      }

      if (filter.timestampRange) {
        const [start, end] = filter.timestampRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.subscriber_activities.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('subscriber_activities', 'action', query),
        ],
      };
    }

    const records = await db.subscriber_activities.findAll({
      attributes: ['id', 'action'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['action', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.action,
    }));
  }
};
